# Creative Flight

![Banner Image](https://i.imgur.com/fV8R9eg.png)

## Description

Allows you to fly as high as you like.

- Double tap space to turn on the jetpack
- Hold space to ascend. 
- Double tap C to turn off the jetpack and fall to the ground.
- Hold C to descend.

Space and C cannot be configured due to issues with BepInEx's key detection code.

**Modders:** Use ```CreativeFlightPlugin.isEnabled``` to toggle creative flight. 

## Config Options

| Name                 |   Type  | Description                                                                                   | Default Value |    Range    |
|----------------------|:-------:|-----------------------------------------------------------------------------------------------|:-------------:|:-----------:|
| Double Tap Threshold | Integer | The time interval in milliseconds during which two key presses are registered as a double tap |      300      |   0 -> 500  |
| Horizontal Thrust    | Decimal | Controls horizontal acceleration while flying                                                 |       10      |      0+     |
| Vertical Thrust      | Decimal | Controls vertical acceleration while flying                                                   |      150      |      0+     |
| Friction             | Decimal | Controls how quickly you slow to a stop while flying                                          |      0.15     | 0.01 -> 0.9 |

For friction, this is the percentage of speed that will be lost every frame. By default, it's at 15% and that results in a rather quick stop. Lower values will increase your max speed, but also make you take longer to stop moving when you let go of keys.

&nbsp;
## Installation

If you are using Techtonica Mod Loader, you can ignore these steps.

Note, this mod requires use of the BepInEx Update function. If you have not already done so for another mod, follow these instructions:
1. Find your game install folder.
2. Navigate to BepInEx\config.
3. Open BepInEx.cfg.
4. Find the setting "HideGameManagerObject".
5. Set it to "true".
6. Save & close.

### Techtonica Mod Loader Installation

You can download the Techtonica Mod Loader from [here](https://github.com/CubeSuite/TechtonicaModLoader/releases) and use that to install this mod.

### Manual Install Instructions

Note: If you are playing on Gamepass, your game version is likely behind the steam version. Please check the version compatibility chart below.

Your game folder is likely in one of these places:  
    • Steam: (A-Z):/steam/steamapps/common/Techtonica  
    • Gamepass: (A-Z):/XboxGames/Techtonica/Content  
    • Gamepass: Could also be in C:/Program Data/WindowsApps  

1. Download BepInEx v5.4.21 from [here](https://github.com/BepInEx/BepInEx/releases)
2. Follow the installation instructions [here](https://docs.bepinex.dev/articles/user_guide/installation/index.html)
3. Extract the contents of the .zip file for this mod.
4. Drag the "BepInEx" folder into your game folder.
5. Change config options. 

## Version Compatibility

|  Mod Version  |  Game Version  |
|:-------------:|:--------------:|
|     v1.x.x    |     v0.3.0e    |
|     v0.3.0    |     v0.2.1c    |
|     v0.2.0    |     v0.2.0h    |
|     v0.0.1    |     v0.1.2a    |

## Changelog

### V1.0.1

- Fixed a bug that caused players to ascend after auto-crouching.

### V1.0.0

- Fully rewrote the mod
- Abandoned the game's stilt system and rewrote the movement calculations while flying.
  - This results in a much smoother flying experience.
- Fixed being able to ascend through the roof.
- Fixed suddenly jumping up when the terrain below you changes.

### V0.3.0

- Added a bool to allow other mods to toggle creative flight.

### V0.2.0

- Added ability to double tap descend key to turn off flight
- Made movement smoother
- Updated for game version v0.2.0h

### V0.0.1

Initial release.

&nbsp;
## Disclaimer

Note: NEW Games must be loaded, saved, and reloaded for mods to take effect. Existing saves will auto-apply mods. 
Please be sure to backup your saves before using mods: AppData\LocalLow\Fire Hose Games\Techtonica 
USE AT YOUR OWN RISK! Techtonica Devs do not provide support for Mods, and cannot recover saves damaged by mod usage.

Some assets may come from Techtonica or from the website created and owned by Fire Hose Games, who hold the copyright of Techtonica. All trademarks and registered trademarks present in any images are proprietary to Fire Hose Games.
